* ROMAN - Convert number to roman numerals
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0.01, PWITTE December 19th 1992
* V0.02, pjw, 2023 Sep 03, extracted from toolkit and tidied
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef ROMAN

        xref cv_roman

        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_err


*
ROMAN
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* romnum$ = ROMAN$(number%)
*
* where number% is in the range of 1 to 3999 else null is returned
*
        move.w sb.gtint,a2
        jsr (a2)
        bne.s exit

        subq.w #1,d3
        bne.s err_bp

        move.w  (a6,a1.l),d0
          bmi.s err_bp

        cmpi.w  #4000,d0
          bge.s err_or

        addq.l  #2,a1
        move.l a1,sb_arthp(a6)

        movea.l (a6),a0
        bsr     cv_roman

        addq.l  #$03,d1
        bclr    #$00,d1
        move.l  d1,d4
        movea.w qa.resri,a2
        jsr     (a2)

        sub.l   d4,sb_arthp(a6)
        movea.l sb_arthp(a6),a1
        lsr.w   #$01,d4
        bra.s   mvle

mvl     move.w  $00(a6,a0.l),$00(a6,a1.l)
        addq.l  #$02,a0
        addq.l  #$02,a1
mvle
        dbf     d4,mvl

        movea.l sb_arthp(a6),a1
        moveq   #ar.strng,d4
        moveq   #0,d0

exit
        rts
; 
err_bp
        moveq #err.ipar,d0
        rts

err_or
        moveq #err.orng,d0
        rts

*
        end
