*
* Convert decimal to roman numerals range 0 - 3999
*  PWITTE December 19th 1992
* V0.02, pjw, 2023 Sep 03, Changed 0 to nul
*
        section code

        xdef cv_roman

cv_roman
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert word in d0 to roman numeral string in buffer. Takes max 17b buffer
*
* input  : d0.w = number
*          a0  -> start of buffer (a6 rel)
* output : d1   = len
*          a0  -> len + roman (a6 rel)
*
         tst.w d0
         bne.s rom_cv
;         move.l #$00013000,0(a6,a0.l) ;len=1 string='0'
         clr.w (a6,a0.l)            ;Romans didnt have zero!
         moveq #0,d1                ;ret len
         rts
rom_cv
         movem.l d2-d4/a0/a2/a3,-(a7)
         lea.l tab_romv(pc),a2      ;a2->table of values
         lea.l tab_roms(pc),a3      ;a3->table of symbols
         moveq #0,d4                ;d4=len
         moveq #13-1,d3             ;d3=counter
rom_lp1
         move.w (a2),d2             ;d2=whole roman value
rom_lp2
         sub.w d2,d0                ;trial subtraction
         bmi.s rom_oops             ;too far!
         move.b (a3),2(a6,a0.l)     ;ok, put symbol in place
         addq.l #1,a0               ;move to next char position
         tst.b 1(a3)                ;has this symbol only one char?
         beq.s rom_ad1              ; yes, so add one to len
         move.b 1(a3),2(a6,a0.l)    ;no, so move next byte in place
         addq.l #1,a0               ; and point to next char pos
         addq.w #2,d4               ; and add 2 to len
         bra.s rom_lp2              ;try again
rom_ad1
         addq.w #1,d4               ;increment len by one
         bra.s rom_lp2
rom_oops
         add.w d2,d0                ;add back too high value
         addq.l #2,a2               ;point at lower value
         addq.l #2,a3               ;point to that value's symbol
         dbra d3,rom_lp1            ;try this value

         move.l d4,d1               ;move len out of the way
         movem.l (a7)+,d2-d4/a0/a2/a3
         move.w d1,0(a6,a0.l)       ;put len in place
         rts
*
tab_romv
         dc.w 1000,900,500,400,100,90,50,40,10,9,5,4,1
tab_roms
         dc.b 'M',0,'CM','D',0,'CD','C',0,'XC','L',0,'XL'
         dc.b 'X',0,'IX','V',0,'IV','I',0

*
         end
